﻿using System;
namespace Memento.Ejm1
{
    /// <summary>
    /// Originador,es la clase que cambia el estado
    /// </summary>
    class Originator
    {
        private String State;

        public void Set(String state)
        {
            Console.WriteLine("Originator: Setting state to " + state);
            this.State = state;
        }

        public Memento SaveToMemento()
        {
            Console.WriteLine("Originator: Saving to Memento.");
            return new Memento(State);
        }

        public void RestoreFromMemento(Memento m)
        {
            State = m.GetSavedState();
            Console.WriteLine("Originator: State after restoring from Memento: "
                    + State);
        }
    }
}
